
#include "drawmaps.h"

int curr,prev;
token get_tokenk();


token get_token(){
	
	int ch,chn,i;

	ch = next_char();
	if ( isdelim(ch) )
		return(get_token()); /* eat white space */
	switch (ch){


		case '#':
			chn = next_char();
			switch (chn){
				case 'N':
					return(TOK_NAME);
				case 'L':
					return(TOK_LATL);
				default:
					/* toss any other lines */
					finish_line();
					return( get_token() );
			}
			break; /* not needed */

		case '0': case '1': case '2': case '3': case '4':
		case '5': case '6': case '7': case '8': case '9':
			value = ch - '0';
			chn = next_char();
			if (isdigit(chn)){
				value = value*10+chn-'0';
				chn = next_char();
				if (isdigit(chn)){
					value = value*10+chn-'0';
				}
			} /* no more than 3 digits per number */
			return(TOK_NUMB);
			break; /* not needed */

		case '(':
			return(TOK_LPAR);
		case ')': 
			return(TOK_RPAR);
		case '/': case '\\':
			return(TOK_SLSH);
		
		default: /* it begins with a letter */
			buf[0] = ch;
			chn = next_char();
			if (isspace(chn)){
				switch(ch){
					/* recognize special cases */
					case 'N':
						return(TOK_NNNN);
					case 'S':
						return(TOK_SSSS);
					case 'E':
						return(TOK_EEEE);
					case 'W':
						return(TOK_WWWW);
					default:
						buf[1]='\000';
						return(TOK_WORD);
				}
			}
			buf[i=1]=chn;
			do{
				buf[++i]=next_char();
			}while( !isdelim(buf[i]) );
			buf[i]='\000';
			return(TOK_WORD);
	}
}


void eat_line(){

	while ( next_char() != '\n' );
}

int next_char(){
	int i;
	prev=curr;
	i =curr= getchar();
	if (i==EOF) draw_map();
	return(i);
}

finish_line(){

	if ((prev=='\n')||(curr=='\n'))return;
	eat_line();
}
