


#include "drawmaps.h"
extern void eat_line();

struct entry *get_entry(){

	static token t;
	struct entry *host;
	struct connection *conn,*conn_tail=0;
	int i;
	float f;

	host = (struct entry*)malloc(sizeof(struct entry));
	host->next = 0;
	host->neighbors=0;

get_entry_top:

	while( t != TOK_NAME )t=get_token();
	if ( (t=get_token())!= TOK_WORD){
		fprintf(stderr,"Need a host name after #N\n");
		goto get_entry_top;
		/* if no name after #N find next host */
	}
	/* may need to remove trailing chars from name */
	host->name = (char *)malloc(strlen(buf));
	strcpy(host->name,buf);
	if (show_links)printf("%s\t",host->name);
	finish_line(); /*  some hosts have extraneous stuff on line */
	t = get_token();
	if (t != TOK_LATL){
		fprintf(stderr,"Host %s has no #L line\n",host->name);
		host->lat = host->lng =0;
		goto get_entry_get_conns;
	}
	t = get_token();
	if (t != TOK_NUMB){
		fprintf(stderr,"%s: need a number after #L\n",host->name);
		host->lat = host->lng =0;
		goto get_entry_get_conns;

	}
	host->lat = value;
	t = get_token();
	if (t != TOK_NUMB){
		fprintf(stderr,"%s: need minutes\n",host->name);
		host->lat = host->lng =0;
		goto get_entry_get_conns;

	}
	host->lat += (float)value/60;
	t=get_token();
	if (t == TOK_NUMB){
		host->lat += (float)value/3600;
		t = get_token();
	}
	switch(t){
		case TOK_SSSS:
			host->lat =-host->lat;
		case TOK_NNNN:
			t = get_token();
			if (t !=TOK_SLSH){
				fprintf(stderr,"%s: need /\n",host->name);
				host->lng = host->lat =0;
				goto get_entry_get_conns;
			}
			break;
		default:
			fprintf(stderr,"%s: Latitude must be N or S\n",host->name);
			host->lng = host->lat =0;
			goto get_entry_get_conns;
			break;
	}
	t = get_token();
	if (t != TOK_NUMB){
		fprintf(stderr,"%s: need number afer /\n",host->name);
		host->lng = 0;
		goto get_entry_get_conns;
	}
	host->lng = value;
	t = get_token();
	if (t != TOK_NUMB){
		fprintf(stderr,"%s: need minutes\n",host->name);
		host->lng = 0;
		goto get_entry_get_conns;
	}
	host->lng += (float)value/60;
	t=get_token();
	if (t == TOK_NUMB){
		host->lng += (float)value/3600;
		t = get_token();
	}
	if (show_links)printf("(%f,%f)\n",host->lng,host->lat);

get_entry_get_conns:

	/* now update connection list, this is the hard part */
	host->size=0;
	frag=host;
	host->neighbors=0;
	host->next=0;
	i=0;
	while(  (t != TOK_WORD) || (strcmp(buf,host->name)) ){
		/* find line starting with this host name */
		if (t == TOK_NAME) goto get_entry_bail;
		if (i)finish_line();else i=1; 
		t=get_token();
	}
	if (show_links)printf(":");
	while ( (t=get_token()) ==TOK_WORD){
		/* add each site to list */
		conn=(struct connection*)malloc(sizeof(struct connection));
		if (!conn_tail){
			host->neighbors=conn_tail=conn;
		}else{
			conn_tail->next=conn;
			conn_tail=conn_tail->next;
		}
		/* get name of site */
		i=0;
		while ( buf[i]&&(buf[i] !=',')&&(buf[i] !='(')&&(!isspace(buf[i])) )i++;
		buf[i]='\000';
		conn->name =(char*)malloc(strlen(buf));
		strcpy(conn->name,buf);
		if (show_links)printf(", %s",conn->name);
		host->size++;
		conn->next=0;
		/* later add in cost */
	}

get_entry_bail:

	if (show_links)printf("\n");
	/* done this host */

	return(host);
}

	
			
