
#include <stdio.h>
#include <string.h>

#define TOK_NAME	1
#define TOK_LATL	2
#define TOK_WORD	4
#define TOK_NUMB	5
#define TOK_NNNN	6
#define TOK_SSSS	7
#define TOK_EEEE	8
#define TOK_WWWW	9
#define TOK_SLSH	10
#define TOK_LPAR	11
#define TOK_RPAR	12
#define TOK_PLUS	13
#define TOK_MINS	14
#define TOK_MULT	15
#define TOK_CMMA	16
#define TOK_EOF		-1
#define MAXSTRSIZE	64

typedef int token;

struct entry {
	char *name;
	float lat;
	float lng;
	int id;
	int size;
	struct connection *neighbors;
	struct entry *next;
};
struct connection {
	char *name;
	int id;
	int cost;
	struct connection *next;
};

	
extern int next_char();
extern token get_token();
extern void eat_line();
extern struct entry *find_host(),*get_entry();

extern int value,show_links;
extern char buf[MAXSTRSIZE];
extern struct entry *host_list,*host_tail,*frag;

#define isdelim(x) ( isspace(x)||((x)== ',')||((x)=='\047')||((x)=='\042')||((x)=='=')||((x)=='`')||((x)=='{')||((x)=='}') )
